﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.DragDrop;
using Telerik.Windows.Controls;
using SilverlightApplication1.ViewModels;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            DragDropManager.AddDragInitializeHandler(regionsList, OnDragInitialize);
            DragDropManager.AddDragInitializeHandler(treatmentsList, OnDragInitialize);
            DragDropManager.AddDropHandler(this.xDiagram, OnDiagramDrop);
        }

        private void OnDiagramDrop(object sender, Telerik.Windows.DragDrop.DragEventArgs e)
        {
            e.Handled = true;
            NodeBase droppedData = e.Data as NodeBase;
            droppedData.DropPosition = e.GetPosition(xDiagram);
            (this.xDiagram.GraphSource as DiagramViewModel).AddNode(droppedData);
        }


        private void OnDragInitialize(object sender, DragInitializeEventArgs args)
        {
          
            args.AllowedEffects = DragDropEffects.All;
            args.Data = ((FrameworkElement)args.OriginalSource).DataContext;
            args.DragVisual = new ContentControl { Content = args.Data, ContentTemplate = this.Resources["ListItemTemplate"] as DataTemplate };

        }
    }
}
