﻿using System;
using System.Collections.Generic;
using System.Linq;
using Telerik.Windows.Diagrams.Core;
using System.Collections.ObjectModel;

namespace SilverlightApplication1.ViewModels
{
    public class DiagramViewModel : IObservableGraphSource
    {
        public DiagramViewModel()
        {
            this.InternalItems = new ObservableCollection<NodeBase>();
            this.InternalEdges = new ObservableCollection<CustomLink>();
        }
        public ObservableCollection<NodeBase> InternalItems
        {
            get;
            private set;
        }

        public ObservableCollection<CustomLink> InternalEdges
        {
            get;
            private set;
        }

        IEnumerable<ILink> IGraphSource.Links
        {
            get { return this.InternalEdges; }
        }

        System.Collections.IEnumerable IGraphSource.Items
        {
            get { return this.InternalItems; }
        }

        #region IObservableGraphSource Members

        public void AddLink(ILink link)
        {
            this.InternalEdges.Add((CustomLink)link);
        }

        public void AddNode(object node)
        {
            if (node is Region)
            { 
                this.InternalItems.Add(new Region()
                {
                    DropPosition = (node as Region).DropPosition,
                    Name = (node as Region).Name
                });
            }
            else
            {
                ITreatment tr = new ITreatment() {
                    DropPosition = (node as ITreatment).DropPosition,
                    Name = (node as ITreatment).Name
                };

                this.InternalItems.Add(tr);
               
                foreach (var item in this.InternalItems)
                {
                    if (item is Region && !(item as Region).Treatments.Contains(node))
                    {
                        (item as Region).Treatments.Add(tr);
                        this.AddLink(new CustomLink() { Source = (Region)item, Target = tr });
                    }
                }
            }

        }

        public ILink CreateLink(object source, object target)
        {
            throw new NotImplementedException();
        }

        public object CreateNode(IShape shape)
        {
            throw new NotImplementedException();
        }

        public bool RemoveLink(ILink link)
        {
            throw new NotImplementedException();
        }

        public bool RemoveNode(object node)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region IGraphSource Members

        public System.Collections.IEnumerable Items
        {
            get { throw new NotImplementedException(); }
        }

        public IEnumerable<ILink> Links
        {
            get { throw new NotImplementedException(); }
        }

        #endregion
    }
}
